/********************************************************************
:2017317
  :PDSNurbs.h
ԭʼ:
    :ǾB

޸ļ¼:
  汾       ޸                ޸
*********************************************************************/
#ifndef _PDS_NURBS_H_
#define _PDS_NURBS_H_

#include <math.h>
#include <afxwin.h>
#include <afxtempl.h>

const double PDS_NURBS_ZERO = 0.000001;  // СڸֵֵΪ0

//ȫֺ

//ж˫Ƿ
BOOL PDSNurbs_IsEqual(double d1, double d2);

//ж˫Ƿ񲻵
BOOL PDSNurbs_NotEqual(double d1, double d2);

//жϸ˫Ƿ0
BOOL PDSNurbs_EqualZero(double d);

//жϸ˫ǷΪ0
BOOL PDSNurbs_NotEqualZero(double d);

//ǾBʹõĵ
class CPDSNurbsPoint : public CObject
{
public:
  double x;
  double y;
  double z;
  double weight;  /* Ȩ,Ĭֵ:1
                  // :(1,1,1,1)ͬ(4,4,4,4),ΪĳһȨصʱ,һҪxyzȫweightܱ֤λò */

  double knot;  // õӦĽڵֵ,Ĭֵ:0

  int type;  // ,=1 ת۵,=0 ߵ,Ĭֵ:0,[20180322 syf]Ӹñ
             // thisʾƵʱ,øñ,ôڷߵĿƵʱ,ת۵Ͽ,ñȺoperator==ж

public:
  CPDSNurbsPoint(void);
  CPDSNurbsPoint(CPDSNurbsPoint& rhs);
  CPDSNurbsPoint(CPoint ptPoint);
  CPDSNurbsPoint(double x, double y, double z = 0.0, double weight = 1.0);
  virtual ~CPDSNurbsPoint(void);
  CPDSNurbsPoint& operator=(CPDSNurbsPoint& rhs);
  CPDSNurbsPoint operator+(CPDSNurbsPoint& rhs);
  CPDSNurbsPoint operator-(CPDSNurbsPoint& rhs);
  void operator+=(CPDSNurbsPoint& rhs);
  BOOL operator==(CPDSNurbsPoint& rhs);

  void Initial(void);

  //thisתΪCPoint
  CPoint GetPoint(void);

  //this
  void SetPoint(CPoint ptPoint);

  //Ըֵ
  void Multiple(double dParam);

  //Ըֵ
  void Divide(double dParam);

  //ÿȨ,õ淶
  void DivideWeight(void);
};

//͵ĵ
class CPDSNurbsPointList : public CList<CPDSNurbsPoint,CPDSNurbsPoint>
{
public:  //չı
public:  //չķ

  CPDSNurbsPointList& operator=(CPDSNurbsPointList& rhs);  //ֵ
  CPDSNurbsPoint& operator[](int iIndex);  //ֵ,Խ

  //listPointthis
  //ر˵:
  //  (1)thisÿz=0,weight=1
  void SetPoint(CList<CPoint,CPoint>& listPoint);

  //thislistPoint
  void GetPoint(CList<CPoint,CPoint>& listPoint);

  POSITION AddWithoutDuplicate(CPDSNurbsPoint ptNurbsPoint, BOOL bAddTail = TRUE);

  void AddWithoutDuplicate(CPDSNurbsPointList& listNurbsPoint, BOOL bAddTail = TRUE);

  //ݸĽڵֵ,ֵ
  int FindKnotIndex(double dKnot);

  //ȡ
  double GetLength(void);

  //thisת
  void Reverse(void);
};

//ڵ
//һNURBS˵(3),ĳӦõڿƵ+4
class CPDSNurbsKnotList : public CList<double,double>
{
public:  //չı
public:  //չķ

  CPDSNurbsKnotList& operator=(CPDSNurbsKnotList& rhs);  //ֵ
  double& operator[](int iIndex);  //ֵ,Խ

  //listKnotthis
  void SetKnot(CList<double,double>& listKnot);

  //thislistKnot
  void GetKnot(CList<double,double>& listKnot);

  //µĽڵ,ڵĽڵ㲻ͬ
  POSITION AddWithoutDuplicate(double dKnot, BOOL bAddTail = TRUE);

  //ҸĽڵthisеظ
  int FindRepeatTime(double dKnot);
};

//
class CPDSMatrix : public CObject
{
protected:
  double** m_dMatrix;  // άָ,Ϊthis˽,ͬĶ֮䲻ܹm_dMatrix
  int m_iRowCount;  // 
  int m_iColumnCount;  // 

public:
  CPDSMatrix(void);
  CPDSMatrix(CPDSMatrix& rhs);
  virtual ~CPDSMatrix(void);
  CPDSMatrix& operator=(CPDSMatrix& rhs);
  CPDSMatrix operator*(CPDSMatrix& rhs);  // thisrhs,

  //ʼ,ͷڴ
  void Initial(void);

  //þĴС
  //ر˵:
  //  ʹþ֮ǰ,һҪôС
  void SetSize(int iRowCount, int iColumnCount);

  //ȡ
  void GetMatrix(double**& dMatrix, int& iRowCount, int& iColumnCount);

  //ȡάָ
  double** GetArray(void);

  //ȡ
  //ر˵:
  //  (1)thisǷ
  //  (2)ݳȱ任
  CPDSMatrix GetInverseMatrix(void);

  //Ϣ
  void OutputDebugInfo(void);

  //еݼ
  //:
  //  dArray1  1,ݱ
  //  dArray2  2,еݱӵdArray1,ݲı
  //  iCount   ĳ
  //  dProp    ֵ,dArray2[]*dPropӵdArray1
  void AddRow(double* dArray1, double* dArray2, int iCount, double dProp = 1.0);

  //еÿһָĲ
  //:
  //  dArray  
  //  iCount  ĳ
  //  dParam  ,ÿһҪԸֵ
  void DivideRow(double* dArray, int iCount, double dParam);
};

//NURBS
//ر˵:
//  (1)ָ3ηǾB
//  (2)ʲôֵ?
//     ָǾĵ,ǵϵͳг֮Ϊ"Ƶ",ʵϹ淶Ķֵ
//     ֵҲϵ
//     Ӣ:data point
//  (3)ʲôǿƵ?
//     ڼʵʵĵ,ְʦĳ֮Ϊ"ֱ",ֻᾭһһ,ᾭм
//     Ƶ,Ҳ,ǷǾB͹,߲ᳬķΧ
//     Ӣ:control point
//  (4)NURBSߵķɵƹʽ,ĵ
//  (5)ʲôǽڵ?
//     һ鵥,ʶÿһcontrol point÷Χ,ͬ˵,ѡͬĽڵ,յЧͬ
//  (6)ڵжٸ?
//     degree=3˵,ڵ=θ+degree+1=θ+4
//     ǰdegree+1=4ڵ(δص0),ĩβdegree+1=4ڵ(δص1)
//     :{A,A,A,A,B,C,D,E,E,E,E}7control pointγɵĽڵ,ÿһ{A,B,C,D,E}Ӧһdata point,data pointĻϿԿĵ
//     {A,B,C,D,E}ɵȲ,߽B,ǾB
//  (7)ֻ3Ƶ,ôֻܼ2
//  (8)ֻ2Ƶ,ôֻܵõһ߶
class CPDSNurbsCurve : public CObject
{
public:
  //4װһ,д,NURBSߵļ㺯ʹóԱ

  CPDSNurbsPointList m_listCtrlPoint;  // Ƶ,Ҳ,յʵʵֻͷβ,м
  CPDSNurbsKnotList m_listKnot;  // ڵ,ȵm_listCtrlPoint.GetCount()+4
  CPDSNurbsPointList m_listDataPoint;  // ֵ,Щ
  CPDSNurbsPointList m_listRealPoint;  // ʵʵ,ֵĵ

public:
  CPDSNurbsCurve(void);
  CPDSNurbsCurve(CPDSNurbsCurve& rhs);
  virtual ~CPDSNurbsCurve(void);
  CPDSNurbsCurve& operator=(CPDSNurbsCurve& rhs);

  void Initial(void);

  //ֵ㿪
  //:
  //  listDataPoint    ֵ
  //  dMaxError        ֵ
  //  bTangentH        =true ͷ,=false ͷû
  //  ptTangentPointH  ͷ߷,ָʵʵGetPrevķ
  //  bTangentT        =true β,=false βû
  //  ptTangentPointT  β߷,ָʵʵGetNextķ
  //:
  //  listOutputPoint  ʵʵ
  //ֵ:
  //  =true ɹ,=false ʧ
  BOOL Calculate_DataPoint_Open(CList<CPoint,CPoint>& listDataPoint, double dMaxError, CList<CPoint,CPoint>& listOutputPoint, BOOL bTangentH = FALSE, CPoint ptTangentPointH = CPoint(0,0), BOOL bTangentT = FALSE, CPoint ptTangentPointT = CPoint(0,0));

  //ֵߵպ
  //:
  //  listDataPoint    ֵ,βԵͷ,ҲԲ,Զ
  //  dMaxError        ֵ
  //:
  //  listOutputPoint  ʵʵ,ʱβͷغ
  //ֵ:
  //  =true ɹ,=false ʧ
  BOOL Calculate_DataPoint_Close(CList<CPoint,CPoint>& listDataPoint, double dMaxError, CList<CPoint,CPoint>& listOutputPoint);

  //ʵʵֵ
  //:
  //  listOldPoint     ɵʵʵ
  //  listDataPoint    ֵ,ʱΪ,ʾ뾭Щ
  //  dSplineError     ߵֵ
  //  dMaxError        ֮,listOldPointֵ
  //  bTangentH        =true ͷ,=false ͷû
  //  ptTangentPointH  ͷ߷,ָʵʵGetPrevķ
  //  bTangentT        =true β,=false βû
  //  ptTangentPointT  β߷,ָʵʵGetNextķ
  //:
  //  listDataPoint  ֵ,ʱΪ,ʾ뾭Щ
  //ֵ:
  //  =true ɹ,=false ʧ
  BOOL ReCalculate_DataPoint(
    CList<CPoint,CPoint>& listOldPoint, CList<CPoint,CPoint>& listDataPoint, double dSplineError, double dMaxError,
    BOOL bTangentH = FALSE, CPoint ptTangentPointH = CPoint(0,0), BOOL bTangentT = FALSE, CPoint ptTangentPointT = CPoint(0,0));

  //ݸĿƵڵʵʵ
  //ر˵:
  //  (1)Զm_listCtrlPointm_listKnot,
  //  (2)ʱҪ֤listKnot.GetCount()=listCtrlPoint.GetCount()+4,NURBSߵҪ,Ҫ֤ڵȷ:,ĽǴ
  //  (3)DXFļжNURBS,ֱӵñʵʵ
  //:
  //  listCtrlPoint  Ƶ
  //  listKnot       ڵ
  //  dMaxError      ֵ
  //:
  //  listDataPoint  ֵ,:߾Щ
  //  listRealPoint  ʵʵ
  //ֵ:
  //  =true ɹ,=false ʧ
  BOOL Calculate_CtrlPoint(CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot, double dMaxError, CPDSNurbsPointList& listDataPoint, CPDSNurbsPointList& listRealPoint);

  //ݸĿƵڵֵ
  //:
  //  listCtrlPoint  Ƶ
  //  listKnot       ڵ
  //:
  //  listDataPoint  ֵ,:߾Щ
  //ֵ:
  //  =true ɹ,=false ʧ
  BOOL Calculate_CtrlPoint(CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot, CPDSNurbsPointList& listDataPoint);

protected:

  //ݸֵƵ(㿪)
  //:
  //  listDataPoint    ֵ,ָ߾Щ
  //  bTangentH        =true ͷ,=false ͷû
  //  ptTangentPointH  ͷ߷,ָʵʵGetPrevķ
  //  bTangentT        =true β,=false βû
  //  ptTangentPointT  β߷,ָʵʵGetNextķ
  //:
  //  listCtrlPoint  Ƶ,NURBSߵĿƶλ˵,䳤=listDataPoint.GetCount()+2
  //  listKnot       ڵ
  void CalculateCtrlPoint_Open(CPDSNurbsPointList& listDataPoint, BOOL bTangentH, CPDSNurbsPoint ptTangentPointH, BOOL bTangentT, CPDSNurbsPoint ptTangentPointT, CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot);

  //ݸֵƵ(պ)
  //ر˵:
  //  (1)listInputPointβԵͷ,ҲԲ
  //  (2)listCtrlPointͷβ,ʾٴλصͷ
  //:
  //  listInputPoint  ֵ,ָ߾Щ
  //:
  //  listCtrlPoint  Ƶ,NURBSߵĿƶλ˵
  //  listKnot       ڵ
  void CalculateCtrlPoint_Close(CPDSNurbsPointList& listInputPoint, CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot);

  //ȡ߶εĳ
  //:
  //  listCtrlPoint  Ƶ
  //  iIndex         εֵ,ָ(listCtrlPoint[iIndex], [iIndex+1])γɵ߶,:0ָ([0],[1])
  //ֵ:
  //  ,ֵԽ򷵻0
  double GetSegmentLength(CPDSNurbsPointList& listCtrlPoint, int iIndex);

  //Ҹڵֵ
  //ر˵:
  //  (1)Ľڵλ[listKnot[i],listKnot[i+1]),ôi
  //  (2)עԵlistKnot[i],һҪϸС[i+1]
  //  (3)NURBSߵĶ֪,{A,A,A,A...}ǰĸظ,Ըúķֵ3ʼ
  //:
  //  listKnot  ڵ,
  //  dKnot     ڵ
  //ֵ:
  //  ֵ,0ʼ,Ϊ-1ʾʧ
  int FindKnotIndex(CPDSNurbsKnotList& listKnot, double dKnot);

  //ݸĽڵֵ,Bֵ
  //ر˵:
  //  (1)һݹ麯,ҪiDegree-1ݽм
  //  (2)ڼĹпַܳĸΪ0/0,˴Ƕ0/0=0
  //:
  //  listKnot  ڵ
  //  dKnot     Ľڵֵ
  //  iIndex    dKnotڵֵ
  //  iDegree   NURBSߵĴ,һ3,ֻƵ,ôֻ2
  //ֵ:
  //  Bֵ
  double CalculateKnot(CPDSNurbsKnotList& listKnot, double dKnot, int iIndex, int iDegree);

  //ݸĽڵֵ,NURBSϵĵ
  //:
  //  listCtrlPoint  Ƶ
  //  listKnot       ڵ
  //  dKnot          Ľڵֵ
  //  iDegree        ߵĴ
  //ֵ:
  //  ĵλ
  CPDSNurbsPoint CalculateNurbsPoint(CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot, double dKnot, int iDegree);

  //ݸڵ,Ҹ
  //:
  //  listCtrlPoint     Ƶ
  //  listKnot          ڵ
  //  ptPrevNurbsPoint  ǰһ
  //  dPrevKnot         ǰһĽڵ
  //  ptNextNurbsPoint  һ
  //  dNextKnot         һĽڵ
  //  iDegree           ߵĴ
  //ֵ:
  //  Ҹ
  double CalculateChordHeight(
    CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot,
    CPDSNurbsPoint ptPrevNurbsPoint, double dPrevKnot, 
    CPDSNurbsPoint ptNextNurbsPoint, double dNextKnot, int iDegree);

  //ݸȷֺĽڵ
  //ر˵:
  //  (1)dPrevKnot=dNextKnot,ôΪ
  //:
  //  dPrevKnot  ǰһڵ
  //  dNextKnot  һڵ
  //  iCount     ڵ֮ĵ,=2,ʾ2,Ϊ{dPrevKnot,ڵ1,ڵ2,dNextKnot}
  //:
  //  listDivideKnot  ָĽڵ,dPrevKnotdNextKnot
  void CalculateDivideKnot(double dPrevKnot, double dNextKnot, int iCount, CPDSNurbsKnotList& listDivideKnot);

  //ڵ֮ʵʵ
  //ر˵:
  //  (1)dPrevKnot=dNextKnot,ôֻһ
  //:
  //  listCtrlPoint  Ƶ
  //  listKnot       ڵ
  //  dPrevKnot      ǰһڵ
  //  dNextKnot      һڵ
  //  iDegree        ߵĴ
  //  dMaxError      ֵ,:ÿ߶εҸֵ߲ܳ
  //:
  //  listOutputPoint  ʵʵ,dPrevKnotdNextKnotӦĵ
  void CalculateNurbsPoint_BetweenTwoKnot(
    CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot, double dPrevKnot, double dNextKnot,
    int iDegree, double dMaxError, CPDSNurbsPointList& listOutputPoint);

  //ݵȷֺĽڵʵʵ
  //:
  //  listCtrlPoint   Ƶ
  //  listKnot        ڵ
  //  listDivideKnot  ȷֺĽڵ
  //  iDegree         ߵĴ
  //  dMaxError       ֵ,:ÿ߶εҸֵ߲ܳ
  //:
  //  listOutputPoint  ʵʵ,ɹ,Ϊ,ʧ,Ϊ
  void CalculateNurbsPoint_UseDivideKnot(
    CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot, CPDSNurbsKnotList& listDivideKnot,
    int iDegree, double dMaxError, CPDSNurbsPointList& listOutputPoint);

  //е
  //:
  //  ptPrevNurbsPoint  ǰһ,weightȥ֮
  //  ptNextNurbsPoint  һ,weightȥ֮
  //ֵ:
  //  е,weight=1
  CPDSNurbsPoint GetMiddleNurbsPoint(CPDSNurbsPoint ptPrevNurbsPoint, CPDSNurbsPoint ptNextNurbsPoint);

  //֮ľ
  //:
  //  ptPrevNurbsPoint  ǰһ,weightȥ֮
  //  ptNextNurbsPoint  һ,weightȥ֮
  //ֵ:
  //  
  double TwoNurbsPointLength(CPDSNurbsPoint ptPrevNurbsPoint, CPDSNurbsPoint ptNextNurbsPoint);

  //ݸ߶ϵĲ,õ
  CPDSNurbsPoint ParamToNurbsPoint(CPDSNurbsPoint ptPrevNurbsPoint, CPDSNurbsPoint ptNextNurbsPoint, double dParam);

  //еĸ,ֵ
  //:
  //  listPoint   
  //  ptSelPoint  
  //:
  //  dMinDistance  
  //ֵ:
  //  ֵ,0ʼ
  int FindNearestIndex(CList<CPoint,CPoint>& listPoint, CPoint ptSelPoint, double& dMinDistance);

  //ۼҳķʽɽڵ
  //:
  //  listDataPoint  ֵ,3
  //:
  //  listUniqueKnot  ظĽڵ
  //  listKnot        ظĽڵ
  void GenerateKnot_ChordLength(CPDSNurbsPointList& listDataPoint, CPDSNurbsKnotList& listUniqueKnot, CPDSNurbsKnotList& listKnot);

  //㴹ʸϵĲֵ
  //:
  //  ptNurbsPointS  ʸS
  //  ptNurbsPointE  ʸE
  //  ptNurbsPoint1  
  //ֵ:
  //  ʸϵĲ,SEغֱӷ0
  double GetNurbsPointVerticalParam(CPDSNurbsPoint ptNurbsPointS, CPDSNurbsPoint ptNurbsPointE, CPDSNurbsPoint ptNurbsPoint1);

  //ȡ㵽ľ
  //:
  //  ptNurbsPoint1   
  //  listNurbsPoint  
  //ֵ:
  //  
  double DistanceOfNurbsPointPloyline(CPDSNurbsPoint ptNurbsPoint1, CPDSNurbsPointList& listNurbsPoint);

  //еĸ
  //:
  //  ptNurbsPoint1   
  //  listNurbsPoint  
  //:
  //  dDistance  
  //ֵ:
  //  
  CPDSNurbsPoint FindNearestNurbsPoint(CPDSNurbsPoint ptNurbsPoint1, CPDSNurbsPointList& listNurbsPoint, double& dDistance);

  //жľǷСֵ
  //:
  //  listOldPoint  ɵ
  //  listNewPoint  µ
  //  dMaxError     ֵ
  //ֵ:
  //  =true ÿ,ľ붼Сڻߵֵ,=false ĳľֵ
  BOOL DistanceSmallerThanError(CList<CPoint,CPoint>& listOldPoint, CList<CPoint,CPoint>& listNewPoint, double dMaxError);

  //ݸĿƵڵʵʵ,ʵʵɵľС
  //:
  //  listCtrlPoint  Ƶ
  //  listKnot       ڵ
  //  iSelIndex      ֵ,0ʼ,Ӹֵʼ,ǰμ,Ƚƫ,ֵƫ
  //  dSplineError   NURBSߵֵ
  //  dMaxError      ʵʵɵֵ
  //  listOldPoint   ɵ
  //ֵ:
  //  =true ɹ,ÿ㶼Сڵֵ,=false ʧ,ĳľֵ
  BOOL Calculate_CtrlPoint_SmallerThanError(CPDSNurbsPointList& listCtrlPoint, CPDSNurbsKnotList& listKnot, int iSelIndex, double dSplineError, double dMaxError, CList<CPoint,CPoint>& listOldPoint);
};

#endif  // _PDS_NURBS_H_